/************************************************************************/
/*	faio.h Ver1.0
/*		1993/04/24	by R.Fujimoto
/************************************************************************/

#ifndef _FAIO_H_
#define _FAIO_H_

#define RECORDSIZE 67
#define packedRECORDSIZE 16
#define BUFS 100

#define NORMAL_END		0
#define NOT_INTERPOLATED	1
#define OPEN_ERR		91
#define CLOSE_ERR		92
#define READ_ERR		93
#define SEEK_ERR		94
#define MALLOC_ERR		95
#define ILLEGAL_INPUT		999
#define NO_KEYWORD		998

typedef struct {
	double adstime;
	double qparam[4];
	double qparamerr[3];
	unsigned char sensor[3];
} ADS_DATA;

typedef struct {
  int adstime, eulang[3];
} packedADS_DATA;

/************************************************************************/
/*  faOpen
/*	ǽ	FRF򳫤
/*	
/*		NORMAL_END	ｪλ
/*		SEEK_ERR	fseek
/*		READ_ERR	fread
/*		NO_KEYWOD	ޤϽλɤ߽Ф
/************************************************************************/
int faOpen(
	char filename[] /*FRF̾*/
);

/************************************************************************/
/*  faClose
/*	ǽ	FRFĤ
/*	
/*		NORMAL_END	ｪλ
/*		CLOSE_ERR      	fclose
/************************************************************************/
int faClose(void);

/************************************************************************/
/*  faHeader
/*	ǽ	FITSإåɤ߽Ф
/*	
/*		NORMAL_END	ｪλ
/*		ILLEGAL_INPUT	ϥɤ
/************************************************************************/
int faHeader(
	char keyword[],	/* input FITS */
	char value[]	/* output ɤ */
);

/************************************************************************/
/*  faReadADStime
/*	֤߰λɤ߽Фեݥ󥿤򼡤ΰ֤˿ʤ
/*	
/*		꤬֤ͤ
/************************************************************************/
double faReadADStime(void);

/************************************************************************/
/*  faSearchADStime
/*	Ϳ줿Υǡ˥եݥ󥿤ư
/*	
/*		NORMAL_END	ｪλ
/*		ILLEGAL_INPUT	ꤵ줿郎ޤޤƤʤ
/*		SEEK_ERR	fseekԡʥեν
/************************************************************************/
int faSearchADStime(
	double ascatime	/* input  */
);

/************************************************************************/
/*  faReadADSdata
/*	֤߰λǡɤ߽ФADS_DATA¤Τ֤
/*	
/*		NORMAL_END	ｪλ
/*		MALLOC_ERR	Ƽ
/*		READ_ERR	fread
/************************************************************************/
int faReadADSdata(
	ADS_DATA *adsdata	/* output  */
);

/************************************************************************/
/*  faIntrpolQparam
/*    	ǤդλQѥ᥿ޤˤäƵ
/*	
/*		NORMAL_END	ｪλ
/*		NOT_INTERPOLATED
/*			˶ᤤ⤷夬ƱͤǤäΤ
/*			ޤʤä
/************************************************************************/
int faIntrpolQparam(
	double t0,		/* input λ */
	double qparam0[4],	/* input Qѥ᥿ */
	double t1,		/* input λ */
	double qparam1[4],	/* input Qѥ᥿ */
	double t,		/* input ꤹ */
	double qparam[4]	/* output ޤƵ᤿Qѥ᥿ */
);

/************************************************************************/
/*  faAttitude
/*	ǤդλQѥ᥿Ȥλ̤֤
/*	
/*		NORMAL_END	ｪλ
/*		NOT_INTERPOLATED
/*			˶ᤤ⤷夬ƱͤǤäΤ
/*			ޤʤä
/*		ILLEGAL_INPUT	ꤵ줿郎ޤޤƤʤ
/*		MALLOC_ERR	Ƽ
/*		SEEK_ERR	fseekԡʥեν
/*		READ_ERR	fread
/************************************************************************/
int faAttitude(
	double ascatime,		/* input  */
	ADS_DATA *adsdata0,	/* output λ */
	ADS_DATA *adsdata1,	/* output λ */
	double qparam[4]		/* output Qѥ᥿ */
);

/************************************************************************/
/*  faQparam
/*	ǤդλQѥ᥿֤
/*	
/*		NORMAL_END	ｪλ
/*		NOT_INTERPOLATED
/*			˶ᤤ⤷夬ƱͤǤäΤ
/*			ޤʤä
/*		ILLEGAL_INPUT	ꤵ줿郎ޤޤƤʤ
/*		MALLOC_ERR	Ƽ
/*		SEEK_ERR	fseekԡʥեν
/*		READ_ERR	fread
/************************************************************************/
int faQparam(
	double ascatime, 	/* input  */
	double qparam[4]	/* output Qѥ᥿ */
);

/************************************************************************/
/*  ascaQqparam
/*	ǤդλQѥ᥿֤ե FADIR õ
/*	
/*		NORMAL_END	ｪλ
/*		NOT_INTERPOLATED
/*			˶ᤤ⤷夬ƱͤǤäΤ
/*			ޤʤä
/*		OPEN_ERR	б֤λե뤬ʤä
/************************************************************************/
int ascaQparam(
	double ascatime, 	/* input  */
	double qparam[4]	/* output Qѥ᥿ */
);

#endif	/* _FAIO_H_ */
